Not able to change an HG for a host using API call

02/17/2016 12:37 PM - Konstantin Orekhov
Priority: Normal   

Assignee: Amit Karsale   

Category: API   

Target version: 1.14.1   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: 1.10.1

Bugzilla link: 1405992 Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/4052

  

Description

I have a host that is in common/puppet-master (id: 5) HG currently:

[root@spc01 ~]# curl -kSs -H "Content-type:application/json" -u admin:$FOREMAN_PASSWORD 

https://localhost/api/hosts/`hostname -f` | jq '.' | egrep "name|id" | grep -v null

"environment_id": 1,

"environment_name": "production",

"domain_id": 1,

"domain_name": "test.domain.com",

"architecture_id": 1,

"architecture_name": "x86_64",

"operatingsystem_id": 1,

"operatingsystem_name": "CentOS 7.2",

"model_id": 1,

"model_name": "Standard PC (i440FX + PIIX, 1996)",

 "hostgroup_id": 5,

"hostgroup_name": "common",

"owner_id": 3,

<snip>

[root@spc01 ~]#

If I try to change its HG into some other one, I get this error:

[root@spc01 ~]# curl -kSs -H "Content-type:application/json" -u admin:$FOREMAN_PASSWORD -X PUT 

https://localhost/api/hosts/`hostname -f` -d '{ "hostgroup_id": 3 }' | jq '.' {

"error": {

"message": "Resource host not found by id 'spc01.test.domain.com'"

}

}

production log shows me this:

| Started PUT "/api/hosts/spc01.test.domain.com" for 127.0.0.1 at 2016-02-17 01:21:45 +0000

2016-02-17 01:21:45 [app] [I] Processing by Api::V2::HostsController#update as JSON

2016-02-17 01:21:45 [app] [I]   Parameters: {"hostgroup_id"=>3, "apiv"=>"v2", "id"=>"spc01.test.do

main.com", :host=>{"hostgroup_id"=>3}}

2016-02-17 01:21:45 [app] [I] Authorized user admin(Admin User)

2016-02-17 01:21:45 [app] [I] Couldn't find Host::Managed with id=spc01.test.domain.com [WHERE `ho

sts`.`type` IN ('Host::Managed') AND ((`hostgroups`.`id` = 3 OR `hostgroups`.`title` = 3

))] (ActiveRecord::RecordNotFound)

2016-02-17 01:21:45 [app] [I]   Rendered api/v2/errors/not_found.json.rabl within api/v2/layouts/e

rror_layout (1.2ms)

2016-02-17 01:21:45 [app] [I] Completed 404 Not Found in 32ms (Views: 2.2ms | ActiveRecord: 5.3ms)

 As you can see, the reason things fail is that API tries to find my host AS if it is already in a new HG, which is obviously can't be true

unless a new HG is the same as a current one.

05/21/2024 1/3

https://localhost/api/hosts/`hostname
https://localhost/api/hosts/`hostname


Related issues:

Related to Foreman - Bug #11266: Unnested *_id parameters treated as parent r... New 07/31/2015

Related to Foreman - Bug #8343: API resource_scope ignores options Closed 11/11/2014

Related to Foreman - Bug #16403: Updating hostgroups via API with environment... Duplicate 09/01/2016

Related to Foreman - Bug #20204: GET /hostgroup/:hostgroup_id/hosts returns a... Closed 07/04/2017

Associated revisions

Revision 8e81effc - 12/29/2016 09:17 AM - Amit Karsale

Fixes #13775 - merge if data set is present

Revision ed7e5184 - 01/30/2017 11:02 AM - Amit Karsale

Fixes #13775 - merge if data set is present

(cherry picked from commit 8e81effcedafc539cbe3477b5565d9239f1f2f51)

History

#1 - 02/17/2016 12:41 PM - Dominic Cleal

- Related to Bug #11266: Unnested *_id parameters treated as parent resources in API added

#2 - 02/17/2016 12:41 PM - Dominic Cleal

- Related to Bug #8343: API resource_scope ignores options added

#3 - 02/17/2016 12:41 PM - Dominic Cleal

- translation missing: en.field_release set to 123

#4 - 02/23/2016 06:07 AM - Dominic Cleal

- translation missing: en.field_release changed from 123 to 145

#5 - 03/30/2016 08:25 AM - Dominic Cleal

- translation missing: en.field_release deleted (145)

#6 - 04/25/2016 09:14 PM - Konstantin Orekhov

Dominic, what release the fix for this is targeted now?

#7 - 04/26/2016 03:12 AM - Dominic Cleal

There is no release target, I'll decide a release if/when a patch is merged.

#8 - 08/03/2016 01:30 PM - Amit Karsale

Hello Konstantine,

the request format for the API is wrong, you are triggering it as below:

curl -kSs -H "Content-type:application/json" -u admin:$FOREMAN_PASSWORD -X PUT https://localhost/api/hosts/`ho

stname -f` -d '{ "hostgroup_id": 3 }'

 instead it should be triggered as :

curl -kSs -H "Content-type:application/json" -u admin:$FOREMAN_PASSWORD -X PUT https://localhost/api/hosts/`ho

stname -f` -d '{ "host":{"hostgroup_id": 3 }}'

 I have verified it with the mentioned request parameter format and it works absolutely fine. Do let know if you find any problem further.

If it works for you we can close the issue.

#9 - 08/04/2016 02:56 AM - Dominic Cleal

It's not wrong, the nested hash is not required per the API documentation, it's optional. This is a regression as the hostgroup_id top-level parameter is

being misinterpreted.

#10 - 08/04/2016 03:00 AM - Amit Karsale

okay, in that case the `parent_scope` in the code is forming this misinterpreted query, will look for it and post a fix.
#11 - 09/01/2016 03:02 AM - Dominic Cleal

- Related to Bug #16403: Updating hostgroups via API with environment_id set fails to find host group added

#12 - 11/11/2016 02:11 AM - Amit Karsale

- File update_host.png added

Hello Dominic, I have viewed the Documentation and the documentation states "host" hash param is "required", Doc url:

'/apidoc/v2/hosts/update.html'

PFA

#13 - 11/11/2016 02:53 AM - Dominic Cleal

See https://theforeman.org/manuals/1.13/index.html#5.1API, and the support for unwrapped parameters in both Foreman and Rails. The inline API

docs only show the wrapped equivalent, not both.

#14 - 11/25/2016 06:51 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/4052 added

#15 - 12/01/2016 04:03 AM - Amit Karsale

- Assignee set to Amit Karsale

- Target version set to 1.15.6

#16 - 12/29/2016 10:01 AM - Amit Karsale

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 8e81effcedafc539cbe3477b5565d9239f1f2f51.

#17 - 01/03/2017 03:39 AM - Dominic Cleal

- translation missing: en.field_release set to 210

#18 - 01/03/2017 04:19 AM - Daniel Lobato Garcia

- Bugzilla link set to 1405992

#19 - 07/20/2017 09:11 AM - Tomáš Strachota

- Related to Bug #20204: GET /hostgroup/:hostgroup_id/hosts returns all hosts when id  of empty hostgroup is used added

Files

update_host.png 103 KB 11/11/2016 Amit Karsale
